#include <sys/shm.h>
#include <sys/ipc.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#define KEY 1984
#define SIZE 1024

int main(){
	int shmid;
	char *shmaddr;
	struct shmid_ds buf;
	
	shmid = shmget(KEY, SIZE, IPC_CREAT|0666);
	printf("shmid is %d\n",shmid);
	if(shmid == -1){
		fprintf(stderr,"shmget failed errno:%d %s\n",errno, strerror(errno));
		return -1;
	}

	shmaddr = (char *)shmat(shmid, NULL, 0);
	if(*((int *)shmaddr) == -1){
		fprintf(stderr,"shmat failed errno:%d %s\n",errno, strerror(errno));
		return -1;
	}
	strcpy(shmaddr," msg is from high level\n");
	printf("shm:%s\n",shmaddr);

	if(shmdt(shmaddr) == -1){
		fprintf(stderr,"shmdt failed errno:%d %s\n",errno, strerror(errno));
		return -1;
	}

	return 0;
}
